#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    ui->progressBar->setMinimum( 0 );
    ui->progressBar->setMaximum( 100 );
    ui->progressBar->setValue( 0 );
    ui->label->setText( "Thread not runing" );

    this->setWindowTitle( "Thread example, using QThreads" );

    test = false;
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void MainWindow::on_pushButton_clicked()
{
    ui->pushButton->setEnabled( false );
    ui->pushButton_2->setEnabled( false );

    myTh = new myThread();

    if( test ){
         myTh->thTest = true;
    }else{
         myTh->thTest = false;
    }

    connect( myTh, SIGNAL(pbValue(int)), this, SLOT(updatePb(int)) );
    connect( myTh, SIGNAL(finished()), this, SLOT(delTh()));
    myTh->start();

    if( test ){
        ui->label->setText( "Thread is runing in loop mode, threads num: " + QVariant(i).toString() );
    }else{
       ui->label->setText( "Thread is runing, beter catch it :) " );
    }

}

void MainWindow::updatePb( int p )
{
    ui->progressBar->setValue( p );
}

void MainWindow::delTh()
{
    ui->label->setText( "Thread deleted!" );
    delete myTh;

    if( test ){
        on_pushButton_clicked();
    }else{
        ui->pushButton->setEnabled( true );
        ui->pushButton_2->setEnabled( true );
    }

    if( i > 1000 ){
        ui->pushButton->setEnabled( true );
        ui->pushButton_2->setEnabled( true );
        test = false;
    }else{
        ++i;
    }
}

void MainWindow::on_pushButton_2_clicked()
{
    ui->pushButton->setEnabled( false );
    ui->pushButton_2->setEnabled( false );

    i = 0;
    test = true;

    myTh = new myThread();
    myTh->thTest = true;
    connect( myTh, SIGNAL(pbValue(int)), this, SLOT(updatePb(int)) );
    connect( myTh, SIGNAL(finished()), this, SLOT(delTh()));
    myTh->start();
    ui->label->setText( "Thread is runing, test mode 1k loop :) " );

    ui->pushButton->setEnabled( true );
    ui->pushButton_2->setEnabled( true );
}
